#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>
#ifdef __unix__
 #include <unistd.h>
#endif
#ifdef __MSDOS__
 #include <io.h>
#endif
#include "mlist.h"

FILE *mail_in;
char mailin_file[128];

long read_input(FILE * fp, char *to, char *sender, char *home_bbs, char *subject)
{
	char line[128], *p;
	int lv = 0;
	long last_fpos = 0;

	strcpy(home_bbs, bbs);

	while (fgets(line, sizeof(line), fp) != NULL) {
		switch (++lv) {
		case 1:				/* address */
			if (sscanf(line, "SP %6s < %6s", to, sender) != 2) {
				print_error("Invalid input address '%s' (SP TO < FROM expected)\n", line);
				return (-1);
			}
			break;
		case 2:				/* subject */
			strncpy(subject, line, 79);
			subject[79] = '\0';
			if ((p = strchr(subject, '\n')) != NULL)
				*p = '\0';
			break;
		default:				/* body */
			if (strncmp(line, "R:", 2) != 0 || (p = strchr(line, '@')) == NULL) {
				if (lv != 3) {
					home_bbs[40] = '\0';
					if ((p = strpbrk(home_bbs, " \n\t")) != NULL)
						*p = '\0';
				}
				fseek(fp, last_fpos, SEEK_SET);
				return (last_fpos);
			}
			if (*(++p) == ':')
				p++;
			strncpy(home_bbs, p, 40);
		}
		last_fpos = ftell(fp);
	}

	return ((lv < 4) ? -1 : last_fpos);
}

void send_short_msg(char *to, char *bbs, char *from, char *subject, char *body)
{
	FILE *fp;
	char fname[13];

#ifdef __MSDOS__
	strcpy(fname, "MLISTMSG.$$$");
#else
	sprintf(fname, "%s.%d", prgname, getpid());
#endif

	if ((fp = fopen(fname, "a")) == NULL) {
		print_error("Error opening %s: %s\n", fname, strerror(errno));
		return;
	}

	fprintf(fp, "SP %s @ %s < %s\n", to, bbs, from);
	build_string(subject, fp, 1);
	build_string(body, fp, 1);
	fputs("/EX\n", fp);
	fclose(fp);
}
